//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "gpluginpainter.h"
#include "gpluginpainter.moc"
gPluginPainter::gPluginPainter(gPluginPainter *parent, const char *name, int type)
 : QWidget(parent, name)
{
	Type=type;
}


gPluginPainter::~gPluginPainter()
{
}




/*!
    \fn gPluginPainter::paint(QPixmap *)
 */
void gPluginPainter::paint(QPixmap *target)
{
	int iValue=0;
	bool okRet=false;
	int iTemp=0;
	switch(Type)
	{
		case DRAW_Pixmap:
			bitBlt(target,Zone.left(),Zone.top(),&Pixmap,0);
		break;
		case DRAW_GaugeHoriz:
			iValue=Value.toInt(&okRet);
			bitBlt(target,Zone.left(),Zone.top(),&Pixmap,0,0,double(double(Pixmap.width())/double(100))*iValue,Pixmap.height());
		break;
		case DRAW_GaugeVert:
			iValue=Value.toInt(&okRet);
			iTemp=double(double(Pixmap.height())/double(100))*double(iValue);
			bitBlt(target,Zone.left(),Zone.top()+100-iTemp,&Pixmap,0,0,Pixmap.width(),iTemp);
		break;
		case DRAW_GaugeVert2:
			iValue=Value.toInt(&okRet);
			iTemp=double(double(Pixmap.height())/double(100))*double(iValue);
			bitBlt(target,Zone.left(),Zone.top()+Pixmap.height()-iTemp,&Pixmap,0,Pixmap.height()-iTemp,Pixmap.width(),iTemp);
		break;
		default:
		break;
	};
}


/*!
    \fn gPluginPainter::setValue(const QString)
 */
void gPluginPainter::setValue(const QString newValue)
{
	Value=newValue;

}


/*!
    \fn gPluginPainter::setRect(const QRect)
 */
void gPluginPainter::setRect(const QRect newZone)
{
	Zone=newZone;
}


/*!
    \fn gPluginPainter::load(const QString)
 */
void gPluginPainter::load(const QString a)
{
	Pixmap.load(a);
}
